<?php
/*
-------------------------------------------------------------------------
NetEye Webinject Configtool for Wuerth Phoenix NetEye
Copyright (C) 2010 by WUERTHPHOENIX Srl.
author Patrick Zambelli <patrick.zambelli@wuerth-phoenix.com>

http://www.wuerth-phoenix.com
--------------------------------------------------------------------------

 LICENSE

 This file is part of WuerthPhoenix NetEye ConfigurationTool.

 The NetEye ConfigurationTool is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation version 3 of the License.

 NetEye ConfigurationTool is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You can get a copy of the GNU General Public License included to the Dashboard or
 at http://www.gnu.org/licenses/gpl-3.0.txt. Otherwise write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
*/
class editorModel{
	var $link;
	var $error_msg="";
	var $username;


	var $arr_xmlConfigFiles;


	//constructor
	function editorModel(&$xmlPath){

		$this->arr_xmlConfigFiles = $this->discoverXML_files($xmlPath);
		sort($this->arr_xmlConfigFiles);

	}


	/*
	 * Discover all xml files
	 */
	function discoverXML_files($xmlPath){

		$arr_files=array();
		if ($handle = opendir($xmlPath)) {

			/* This is the correct way to loop over the directory. */
			while (false !== ($file = readdir($handle))) {

				//Discover the xml files
				if (strstr(substr($file, strlen($file)-4, 4),".xml")){
					array_push($arr_files, $file);
				}
			}

			closedir($handle);
		}

		return $arr_files;
	}


	/*
	 * Define and write new testcase
	 */
	function defineNewTestcase($xmlFolder, $testcase_id, $testcase_name, $testcase_desc, $testcase_url,
	$testcase_method, $testcase_postbody, $testcase_posttype, $testcase_verifypositive, $testcase_verifynegative,
	$testcase_parseresponse, $testcase_sleep, $testcase_logrequest, $testcase_logresponse, &$message){

		// create doctype
		$dom = new DOMDocument("1.0", "iso-8859-1");

		// create root cd_collection element
		$conf_testcases = $dom->createElement("testcases");
		$dom->appendChild($conf_testcases);

		// create attribute node
		$conf_testcases_repeat = $dom->createAttribute("repeat");
		$conf_testcases->appendChild($conf_testcases_repeat);
		// create attribute value node
		$conf_testcases_repeat_value = $dom->createTextNode("1");
		$conf_testcases_repeat->appendChild($conf_testcases_repeat_value);


		// create case element
		$conf_case = $dom->createElement("case");
		$conf_testcases->appendChild($conf_case);

		if ($testcase_id!="") $this->appendXMLAttribute("id", $testcase_id, $conf_case, $dom);
		if ($testcase_desc!="") $this->appendXMLAttribute("description1", $testcase_desc, $conf_case, $dom);
		if ($testcase_url!="") $this->appendXMLAttribute("url", $testcase_url, $conf_case, $dom);
		if ($testcase_method!="") $this->appendXMLAttribute("method", $testcase_method, $conf_case, $dom);
		if ($testcase_postbody!="")	$this->appendXMLAttribute("postbody", $testcase_postbody, $conf_case, $dom);
		if ($testcase_posttype!="")	$this->appendXMLAttribute("posttype", $testcase_posttype, $conf_case, $dom);
		if ($testcase_verifypositive!="") $this->appendXMLAttribute("verifypositive", $testcase_verifypositive, $conf_case, $dom);
		if ($testcase_verifynegative!="") $this->appendXMLAttribute("verifynegative", $testcase_verifynegative, $conf_case, $dom);
		if ($testcase_parseresponse!="") $this->appendXMLAttribute("parseresponse", $testcase_parseresponse, $conf_case, $dom);
		if ($testcase_sleep!="") $this->appendXMLAttribute("sleep", $testcase_sleep, $conf_case, $dom);
		if ($testcase_logrequest!="") $this->appendXMLAttribute("logrequest", $testcase_logrequest, $conf_case, $dom);
		if ($testcase_logresponse!="") $this->appendXMLAttribute("logresponse", $testcase_logresponse, $conf_case, $dom);

		$ret = $this->write_webinject_xml_file($dom->saveXML($conf_testcases), $xmlFolder."/".$testcase_name);
		if ( $ret == 0 ) {

			$message.="Done: The Webinject testcase $testcase_name has been created with success.<br>";
		} else {
			$message.="Exception while saving the new Webinject testcase $testcase_name.<br>";
		}

	}

	/*
	 * Prepare the arrays for the update of the testcases file
	 */
	function prepare_updateOfTestcases($xmlFullPath_File, $testcase_name, $arr_testcases, &$message){

		$arr_testcase_id[] = ""; $arr_testcase_desc[] = ""; $arr_testcase_url[] = ""; $arr_testcase_method[] = ""; $arr_testcase_postbody[] = "";
		$arr_testcase_posttype[] = ""; $arr_testcase_verifypositive[] = ""; $arr_testcase_verifynegative[] = ""; $arr_testcase_parseresponse[] = "";
		$arr_testcase_sleep[] = "";

		$num_of_testcases = count($arr_testcases);
		for ($i=0;$i<$num_of_testcases;$i++){

			if(isset($arr_testcases[$i]['id'])){ $arr_testcase_id[$i] = $arr_testcases[$i]['id']; }
			if(isset($arr_testcases[$i]['description'])){ $arr_testcase_desc[$i] = $arr_testcases[$i]['description']; }
			if(isset($arr_testcases[$i]['url'])){ $arr_testcase_url[$i] = $arr_testcases[$i]['url']; }
			if(isset($arr_testcases[$i]['method'])){ $arr_testcase_method[$i] = $arr_testcases[$i]['method']; }
			if(isset($arr_testcases[$i]['postbody'])){ $arr_testcase_postbody[$i] = $arr_testcases[$i]['postbody']; }
			if(isset($arr_testcases[$i]['posttype'])){ $arr_testcase_posttype[$i] = $arr_testcases[$i]['posttype']; }
			if(isset($arr_testcases[$i]['verifypositive'])){ $arr_testcase_verifypositive[$i] = $arr_testcases[$i]['verifypositive']; }
			if(isset($arr_testcases[$i]['verifynegative'])){ $arr_testcase_verifynegative[$i] = $arr_testcases[$i]['verifynegative']; }
			if(isset($arr_testcases[$i]['parseresponse'])){ $arr_testcase_parseresponse[$i] = $arr_testcases[$i]['parseresponse']; }
			if(isset($arr_testcases[$i]['sleep'])){ $arr_testcase_sleep[$i] = $arr_testcases[$i]['sleep']; }
		}

		$this->updateTestcases($xmlFullPath_File, $testcase_name, $num_of_testcases, $arr_testcase_id, $testcase_name, $arr_testcase_desc, $arr_testcase_url,
		$arr_testcase_method, $arr_testcase_postbody, $arr_testcase_posttype, $arr_testcase_verifypositive, $arr_testcase_verifynegative,
		$arr_testcase_parseresponse, $arr_testcase_sleep, $message);

	}

	/*
	 * Update and write new testcases
	 */
	function updateTestcases($xmlFullPath_File, &$testcase_name, $num_of_testcases, &$arr_testcase_id, &$testcase_name, &$arr_testcase_desc, &$arr_testcase_url,
	&$arr_testcase_method, &$arr_testcase_postbody, &$arr_testcase_posttype, &$arr_testcase_verifypositive, &$arr_testcase_verifynegative,
	&$arr_testcase_parseresponse, &$arr_testcase_sleep, &$message){

		// create doctype
		$dom = new DOMDocument("1.0", "iso-8859-1");

		// create root cd_collection element
		$conf_testcases = $dom->createElement("testcases");
		$dom->appendChild($conf_testcases);

		// create attribute node
		$conf_testcases_repeat = $dom->createAttribute("repeat");
		$conf_testcases->appendChild($conf_testcases_repeat);
		// create attribute value node
		$conf_testcases_repeat_value = $dom->createTextNode("1");
		$conf_testcases_repeat->appendChild($conf_testcases_repeat_value);

		//iterate as many times as number of test cases are defined
		for ($i=0;$i<$num_of_testcases;$i++){

			// create case element
			$conf_case = $dom->createElement("case");
			$conf_testcases->appendChild($conf_case);

			$arr_testcase_parseresponse[$i] = str_ireplace('"', '\"', $arr_testcase_parseresponse[$i]);

			if ($arr_testcase_id[$i]!="") $this->appendXMLAttribute("id", $i+1, $conf_case, $dom);
			if ($arr_testcase_desc[$i]!="") $this->appendXMLAttribute("description1", $arr_testcase_desc[$i], $conf_case, $dom);
			if ($arr_testcase_url[$i]!="") $this->appendXMLAttribute("url", $arr_testcase_url[$i], $conf_case, $dom);
			if ($arr_testcase_method[$i]!="") $this->appendXMLAttribute("method", $arr_testcase_method[$i], $conf_case, $dom);
			if (isset($arr_testcase_postbody[$i]))	$this->appendXMLAttribute("postbody", $arr_testcase_postbody[$i], $conf_case, $dom);
			if (isset($arr_testcase_posttype[$i]))	$this->appendXMLAttribute("posttype", $arr_testcase_posttype[$i], $conf_case, $dom);
			if (isset($arr_testcase_verifypositive[$i])) $this->appendXMLAttribute("verifypositive", $arr_testcase_verifypositive[$i], $conf_case, $dom);
			if (isset($arr_testcase_verifynegative[$i])) $this->appendXMLAttribute("verifynegative", $arr_testcase_verifynegative[$i], $conf_case, $dom);
			if (isset($arr_testcase_parseresponse[$i])) $this->appendXMLAttribute("parseresponse", $arr_testcase_parseresponse[$i], $conf_case, $dom);
			if ($arr_testcase_sleep[$i]!="") $this->appendXMLAttribute("sleep", $arr_testcase_sleep[$i], $conf_case, $dom);
			$this->appendXMLAttribute("logrequest", "yes", $conf_case, $dom);
			$this->appendXMLAttribute("logresponse", "yes", $conf_case, $dom);

		}

		$res = $this->write_webinject_xml_file($dom->saveXML(), $xmlFullPath_File);
		if ($res == 0) {

			$message.="Done: Testcase $testcase_name written with success";
		} else{
			$message.="Warning: It was not possible to complete writing the testcase $testcase_name to file.";
		}

	}

	/*
	 * Add a single testcase at a determined index
	 */
	function insertSingleCase(&$arr_testcases, $case_insertAtIndex, &$message){

		$arr_testcasesNew = array();

		//This bool to determine the shift of the following case Id's by 1
		$case_hasBeenInserted=false;

		for ($i=0;$i<count($arr_testcases);$i++){

			//if the case has to be inserted after this case
			if ($arr_testcases[$i]['id'] == $case_insertAtIndex){
					
				$case_hasBeenInserted=true;
					
				$arr_testcase = array(12);
				$arr_testcase['id'] = $i+1;
				$arr_testcase['description']= "insert your description";
				$arr_testcase['url'] = "http://";
				$arr_testcase['method'] = "get";
				$arr_testcase['postbody'] = "";
				$arr_testcase['posttype'] = "application/x-www-form-urlencoded";
				$arr_testcase['verifypositive'] = "";
				$arr_testcase['verifynegative'] = "";
				$arr_testcase['parseresponse'] = "";
				$arr_testcase['sleep'] = "1";
				array_push($arr_testcasesNew, $arr_testcase);
					
				$message.="OK: The new case has been inserted at index: $case_insertAtIndex<br/>";
			}

			//shift the next cases by one index
			if ($case_hasBeenInserted){
					
				$arr_testcases[$i]['id'] = $arr_testcases[$i]['id']+1;
			}

			array_push($arr_testcasesNew, $arr_testcases[$i]);
		}

		//insert at the end
		$i++;
		if (($i <= $case_insertAtIndex) && (!$case_hasBeenInserted)){

			$arr_testcase = array(12);
			$arr_testcase['id'] = $i;
			$arr_testcase['description']= "insert your description";
			$arr_testcase['url'] = "http://";
			$arr_testcase['method'] = "get";
			$arr_testcase['postbody'] = "";
			$arr_testcase['posttype'] = "application/x-www-form-urlencoded";
			$arr_testcase['verifypositive'] = "";
			$arr_testcase['verifynegative'] = "";
			$arr_testcase['parseresponse'] = "";
			$arr_testcase['sleep'] = "1";
			array_push($arr_testcasesNew, $arr_testcase);

			$message.="OK: The new case has been inserted at index: $i<br/>";
		}

		//$message.="<br>SAVE YOUR CHANGES: Click on \"Submit configuration\" to safe definitely.";
		return $arr_testcasesNew;
	}

	/*
	 * Remove a single testcase at a determined index
	 */
	function removeSingleCase($arr_testcases, $case_DeleteIndex, &$message){

		$arr_testcasesNew = array();

		$j=1;
		for ($i=0;$i<count($arr_testcases);$i++){

			//if the case has to be inserted after this case
			if ($arr_testcases[$i]['id'] != $case_DeleteIndex){

				$arr_testcases[$i]['id'] = $j;
				$j++;
				array_push($arr_testcasesNew, $arr_testcases[$i]);

			} else {
					
				$message.= "The case at index $case_DeleteIndex has been removed.<br>";
			}

		}
		//$message.="<br>SAVE YOUR CHANGES: Click on \"Submit configuration\" to safe definitely.";
		return $arr_testcasesNew;

	}

	/*
	 * Function to append an attribute to an xml parent DOM element
	 */
	function appendXMLAttribute($attribute, $value, &$parent, &$dom){

		$conf_case_attr = $dom->createAttribute($attribute);
		$parent->appendChild($conf_case_attr);
		// create attribute value node
		$conf_case_attr_value = $dom->createTextNode($value);
		$conf_case_attr->appendChild($conf_case_attr_value);
	}

	/*
	 * Write the XML strings down to file
	 */
	function writeXMLFile($xml_file, $xml_data){

		$ret_val = 0;
		if ($handle = fopen($xml_file, "w")){

			if (!fwrite($handle, $xml_data)) {

				$this->messages .= "Error while writing to xml file $xml_file <br/>";
				$ret_val = 2;
			}

			fclose($handle);

		} else {

			$this->messages .= " Error wrinting to xml file $xml_file <br/>";
			$ret_val = 2;
		}

		$this->messages .= "XML File $xml_file written with success<br/><br>";
		return $ret_val;
	}

	/*
	 * Read out the data from the xml file
	 */
	function parseTestCases_from_XMLConfiguration($testcase_file){

		$arr_testcases = array();
		$xml_strings = $this->get_standard_xml_strings($testcase_file);

		if ($xml_strings == "") return null;

		$doc = new DOMDocument("1.0", "iso-8859-1");
		//if (!$doc->load( $testcase_file )){
		if (!$doc->loadXML( $xml_strings )){

			echo "Error opening xml file.";
			return null;
		}

		$testcases = $doc->getElementsByTagName('case');

		$i=0;
		foreach( $testcases as $testcase){

			$arr_testcase = array(12);
			$arr_testcase['id'] = $testcases->item($i)->getAttribute('id');
			//$arr_testcase['id'] = $i+1;
			$arr_testcase['description']= $testcases->item($i)->getAttribute('description1');
			$arr_testcase['description'].= $testcases->item($i)->getAttribute('description2');
			$arr_testcase['url'] = $testcases->item($i)->getAttribute('url');
			$arr_testcase['method'] = $testcases->item($i)->getAttribute('method');
			$arr_testcase['postbody'] = $testcases->item($i)->getAttribute('postbody');
			$arr_testcase['posttype'] = $testcases->item($i)->getAttribute('posttype');
			$arr_testcase['verifypositive'] = $testcases->item($i)->getAttribute('verifypositive');
			$arr_testcase['verifynegative'] = $testcases->item($i)->getAttribute('verifynegative');
			$arr_testcase['parseresponse'] = $testcases->item($i)->getAttribute('parseresponse');
			$arr_testcase['sleep'] = $testcases->item($i)->getAttribute('sleep');
			$arr_testcase['logrequest'] = $testcases->item($i)->getAttribute('logrequest');
			$arr_testcase['logresponse'] = $testcases->item($i)->getAttribute('logresponse');

			$i++;
			array_push($arr_testcases, $arr_testcase);
		}

		return $arr_testcases;
	}

	/*
	 * OLD model section
	 */
	/*
	 * Read the xml file ascii test and return it. With write warning in case of missing permission.
	 */
	function readXMLFile($xmlFile){

		$xmlString = "";
		if ($fh = fopen($xmlFile, 'r')){

			if ($rows = file($xmlFile)){
				$num_rows = count($rows);

				for ($i=0;$i<$num_rows;$i++){
					$xmlString = $xmlString.$rows[$i]."";
				}
			}

			fclose($fh);
			return $xmlString;
		} else {
			return " It is not possible to open the File: ".$xmlFile.". No read permissions given!";
		}
	}

	/*
	 * Read and filter the xml file ascii test and return it. With write warning in case of missing permission.
	 */
	function readAndFilterXMLFile($xmlFile, $stringToEclude, $bool_addGlobalHTTPLog, &$message){

		$xmlString = "";
		$bool_globalHTTPConfFound=false;
		
		if ($fh = fopen($xmlFile, 'r')){

			if ($rows = file($xmlFile)){
				$num_rows = count($rows);

				for ($i=0;$i<$num_rows;$i++){
						
					//exclude string
					if (strstr($rows[$i], $stringToEclude)){
						continue;
					}
						
					//activate global log if required
					if ($bool_addGlobalHTTPLog && !$bool_globalHTTPConfFound){
													
						if (strstr($rows[$i], "globalhttplog")){
									
							$rows[$i] = "<globalhttplog>yes</globalhttplog>";
							$bool_globalHTTPConfFound=true;
							$message .=  "Added globalhttplog directive 'yes'. ";		
						}
					}
						
					$xmlString .= $rows[$i]."";
				}
				
				//test if string has not been found, but should be activated
				if ($bool_addGlobalHTTPLog && !$bool_globalHTTPConfFound){
					
					$xmlString.= "<globalhttplog>yes</globalhttplog>\n";
					$message .=  "Added globalhttplog directive 'yes'. ";
				}

			}

			fclose($fh);
			return $xmlString;
		} else {
			return " It is not possible to open the File: ".$xmlFile.". No read permissions given!";
		}
	}

	/*function setTestcaseLogging($xmlFile, $yesNo){

	if (($rows = file($xmlFile))&& ($fh = fopen($xmlFile, 'w'))){

	for ($i=0;$i<count($rows);$i++){

	if (strstr($rows[$i], 'logrequest')){
	$rows[$i] = "   logrequest=\"".$yesNo."\"\n";
	}

	if (strstr($rows[$i], 'logresponse')){
	$rows[$i] = "   logresponse=\"".$yesNo."\"\n";
	}
	fwrite($fh, $rows[$i]);
	}
	fclose($fh);
	return "Set testcase logging: $yesNo.\n\n";

	} else {
	return "Impossible set logging to $yesNo for test run.\n";
	}
	}*/

	function testXMLWritability($xmlFile){

		if ($xmlFile != ''){

			if ($fh = fopen($xmlFile, 'a')){
				fclose($fh);
				return true;
			}
		}
		return false;
	}

	/*
	 * Run a given testcase
	 */
	function run_testcase($testcase_to_run, $webinjectTestrunPath){
		$testResults = "";

		exec($testcase_to_run, $arr_results, $bool_results);
		$testResults .= "Web 2.0 testcase command:\n $testcase_to_run \n";

		if ($bool_results == 127){
			return "ERROR: It was not possible to execute the testcase:\n '$testcase_to_run'\n\nProbable reason: webinject.sh not found. $bool_results";

		} else if ($bool_results == 13){
			return "ERROR: It was not possible to write logfiles in folder '$webinjectTestrunPath'\n";

		} else if ($bool_results == 126){
			return "ERROR: executing $testcase_to_run. Exit code 126.\n";

		} else if ($bool_results == 0) {
			foreach ($arr_results as $row){
				$testResults .="  ".$row."\n";
			}
			return $testResults;

		} else {
			return "ERROR executing the testcase $testcase_to_run.\nPlease check the config.xml and make sure to use the right proxy settings.";
		}
	}

	/*
	 * Read the logfile content to display in debugging form
	 */
	function read_logfile($logFile){

		$logStr="";
		if ($rows = file($logFile)){

			foreach ($rows as $row){

				//$row = str_ireplace("textarea", "REPLACED", $row);
				$logStr .= $row;
			}
			return $logStr;

		} else {

			return "Error: Testcase run did not terminate correctly.";
		}

	}

	function clean_out_resultsXML($configurationFiles){
		$arr = array();
		for ($i=0;$i<count($configurationFiles);$i++){
			if (!strstr(trim($configurationFiles[$i]),'results.xml')){
				array_push($arr, $configurationFiles[$i]);
			}
		}
		return $arr;
	}

	/*
	 * Coordinate the execution of a testcase
	 */
	function start_testcase_execution(&$testRunResultsArray, &$webinjectPath, &$webinjectTestrunPath, $testcase_to_run, &$message, &$origXMLPath){

		$testRunResultsArray[0] = $message;

		//Verify that no testcase is running. Detmine wheter the results.xml is present otherwise
		//wait and then try to delete the file to make sure no other testrun is active.
		if (!$this->check_if_testcasefile_exists($webinjectTestrunPath."results.xml", 0, $testRunResultsArray[0])) { $message.="Error. Another debug run is still not terminated."; return false; }

		//Copy the xml File to run the test for, to the local test folder
		if ($this->copyTestcasefileToRunPath($origXMLPath, $webinjectTestrunPath, $testcase_to_run)) {
			$testRunResultsArray[0] .= "Acquire of ".$testcase_to_run." to perform testrun successful.\n\n";

		}else {

			$message .= "Failded to copy ".$testcase_to_run." to execution directory.<br>";
			//return false;
		}

		//Run the testcase
		$testRunResultsArray[0] .= $this->run_testcase($webinjectPath.' '.$testcase_to_run, $webinjectTestrunPath);

		//read content of results.xml
		$testRunResultsArray[1] = $this->read_logfile($webinjectTestrunPath."http.log");

		//read content of results.html
		$testRunResultsArray[2] = $this->read_logfile($webinjectTestrunPath."results.html");

		if (unlink($webinjectTestrunPath.$testcase_to_run)) {
			$testRunResultsArray[0] .= "Debug and clean of testcase file ".$testcase_to_run." terminated successfully.\n";

		} else {
			$message .= "Info: Failed to remove testcase ".$testcase_to_run." after debug.";
			return false;
		}

		if (unlink($webinjectTestrunPath."results.xml")){
			$testRunResultsArray[0] .= "Successfully cleaned testrun results (results.xml) from testrun folder.\n";
		} else {
			$testRunResultsArray[0] .= "WARNING: Unable to remove testrun lock (results.xml) from testrun folder.\n";
		}

		$message .= "TESTCASE EXECUTED: For result details see section 'Results summary'";
		return true;

	}

	function copyTestcasefileToRunPath($origXMLPath, $webinjectTestrunPath, $testcase_to_run){

		if (copy($origXMLPath.$testcase_to_run, $webinjectTestrunPath.$testcase_to_run)){
			return true;
		} else {
			return false;
		}

	}

	/*
	 * Check if the $testcasefile exists. This indicates another testrun is active. I will wait for 2 seconds and
	 * run the test again. Max retries is 5 times.
	 * After that the testcasefile is tried to be eliminated. If this is not possible I will give up.
	 */
	function check_if_testcasefile_exists ($testcasefile, $runs, &$message){

		if (file_exists($testcasefile)){

			$message .= "Another webinject testcase seems to be running: Waiting 1 second for the $runs st / 5 time.\n";

			if ($runs < 5){

				sleep(1);
				$runs += 1;
				if ($this->check_if_testcasefile_exists($testcasefile, $runs, $message)) { return true; }
			} else {
					
				//after 5 wait tentatives try to delete the file.
				if (unlink($testcasefile)){
					$message .= "Testrun terminated with success.\n";
					return true;

				} else {

					$message .= "Testrun is still not terminated. Giving up.\n";
					return false;
				}
					
			}
		} else {
			return true;
		}
	}

	/*
	 * This is a check to take changes from the global config.xml (usually in /opt/neteye/webinject) to the
	 * copy used for debugging: This copy is required due to the need to cut off the row <reporttype>nagios...
	 * to enable the debugging activity of webinject.
	 */
	function verifyConfigXML($xmlPath, $webinjectTestrunPath, &$message){

		//Test if config.xml of productive webinject has been changed. So copy config.xml to test system.
		if (!file_exists($webinjectTestrunPath."config.xml") || (filemtime($xmlPath."config.xml") > filemtime($webinjectTestrunPath."config.xml"))){

			$configStrings = "";

			$message .= "The global config.xml for debug has to be updated. Updating now...<br/>";

			if (copy($xmlPath."config.xml", $webinjectTestrunPath."config.xml")){

				//remove reporttype from configuration
				$configStrings = $this->readAndFilterXMLFile($webinjectTestrunPath."config.xml", '<reporttype>', true, $message);

				if ($fh = fopen($webinjectTestrunPath."config.xml", 'w')){

					fwrite($fh, $configStrings);
					fclose($fh);

					$message .=  "Updated correctly.<br/>";
					return true;
				} else {

					$message.= "Error: impossible to write to ".$webinjectTestrunPath."config.xml!<br/>";
					return false;
				}

			} else {

				$message.= "Error while updating debug config.xml in folder: ".$webinjectTestrunPath."<br/>";
				return false;

			}
		} else {

			return true;
		}
	}
	
	/*
	 * Verify that the perl webinject.pl is in the testfolder
	 */
	function verifyWebinjectplAvailable($xmlPath, $webinjectTestrunPath, &$messages){
		
		if (!file_exists($webinjectTestrunPath."webinject.pl")){
			
			if (!copy($xmlPath."webinject.pl", $webinjectTestrunPath."webinject.pl")){
				
				$messages.= "Error while copying the webinject.pl for testrun to test folder ".$webinjectTestrunPath;
				return false;
			}
			chmod($webinjectTestrunPath."webinject.pl", 0755);
		}
		
		return true;
	}

	/*
	 * Write down to file the raw XML strings
	 */
	function writeRawXMLtoFile ($rawXMLstrings, $XMLFileFullPath, &$message) {

		//Write testcase xml file
		if (isset($XMLFileFullPath)){
			if ($fh = fopen($XMLFileFullPath, 'w')){

				fwrite($fh, $rawXMLstrings);
				fclose($fh);

				$message.= "Done: Webinject testcase ".array_pop(explode('/',$XMLFileFullPath))." updated with success.<br>";

			} else {
				$message.= "ERROR: It was not possible to open the file ".$XMLFileFullPath." for writing. Abort.";
			}

		} else {

			$message.= "ERROR: There has been indicated no testcase filename. Nothing to do.";
		}
	}

	/*
	 * Remove Webinject XML Testcase configuration
	 */
	function removeTestcaseConfiguration($testcaseToDel, &$xmlFolder, &$message){

		//echo "The testcase to del: $testcaseToDel";
		if (($testcaseToDel == 'config.xml') ||(strstr($testcaseToDel, 'config.xml'))){

			$message .= "ABORT: It is not allowed to delete the global configuration file config.xml !<br>";

		} else {

			//Verify that the testcase name to use for the new one does not exist jet!
			if (!$this->deregisterTestcaseFromConfigXML($testcaseToDel, $xmlFolder, $message)){
				$message .="WARNING: Deletion of testcase definition from config.xml not succeeded! Please verify manually.<br>";
			}

			if (unlink($xmlFolder.$testcaseToDel)){

				$message .="OK: Testcase $testcaseToDel removed with success.<br>";
			} else {

				$message .="WARNING: It was not possible to remove the file $xmlFolder $testcaseToDel<br>";
			}
		}
	}

	/*
	 * Remove the testcase definition from config.xml
	 */
	function deregisterTestcaseFromConfigXML($testcase_name, $xmlFolder, &$message){
		$deleted=false;
		if (($rows = file($xmlFolder.'config.xml'))&& ($fh = fopen($xmlFolder.'config.xml', 'w'))){
			for ($i=0;$i<count($rows);$i++){
				if (strstr($rows[$i], $testcase_name)){
					$rows[$i]='';
					$deleted=true;
					$message .= "OK: Testcase $testcase_name has been deregistered from global config.xml<br>";
				}
				fwrite($fh, $rows[$i]);
			}
			fclose($fh);
		}
		return $deleted;
	}

	/*
	 * Register a new testcase definition in config.xml
	 */
	function registerTestcaseFromConfigXML($testcase_name, $xmlFolder, &$message){

		$alreadyRegistered=false;

		if (($rows = file($xmlFolder.'config.xml'))&& ($fh = fopen($xmlFolder.'config.xml', 'w'))){
			for ($i=0;$i<count($rows);$i++){
				if (strstr($rows[$i], $testcase_name)){

					$alreadyRegistered=true;
				}
				fwrite($fh, $rows[$i]);
			}

			if (!$alreadyRegistered){

				$row = "<testcasefile>$testcase_name</testcasefile>\n";
				fwrite($fh, $row);
			}

			fclose($fh);
		}

		return true;
	}

	/*
	 * Parse webinject xml file and return standard xml data
	 */
	function get_standard_xml_strings($testcase_file){

		$webinject_xml="";
		$arr_webinject_xml = file($testcase_file);
		foreach ($arr_webinject_xml as $row){
			$webinject_xml.=$row;
		}

		return $this->decode_webinject_xml($webinject_xml);
	}

	/*
	 * Write webinject compliant xml file from xml string
	 */
	function write_webinject_xml_file($xml_standard_data, $xmlFullPath_File){

		$xml_file_string = $this->encode_webinject_xml($xml_standard_data);

		return $this->writeXMLFile($xmlFullPath_File, $xml_file_string);
	}

	/*
	 * Prepare standard XML to be written for webinject xml api
	 */
	function encode_webinject_xml($xml_data){

		$xml_webinject="";
		$xml_data = str_ireplace("&amp;", "&", $xml_data);

		$arr_xml_tags = explode("<case", $xml_data);
		for ($i=0;$i<count($arr_xml_tags);$i++){

			if ($i < count($arr_xml_tags)-1) $arr_xml_tags[$i].="\n<case";
			$xml_webinject.=$arr_xml_tags[$i];
		}

		return $xml_webinject;
	}

	/*
	 * Read webinject xml and prepare standard XML
	 */
	function decode_webinject_xml($xml_data){

		$xml_webinject="";
		$xml_data = str_ireplace("&", "&amp;", $xml_data);

		return $xml_data;
	}

	function initilizeHttpAuthentication(){
		if (!isset($_SESSION["username"])){
			if (isset($_SERVER['PHP_AUTH_USER'])){
				$_SESSION["username"] = $_SERVER['PHP_AUTH_USER'];
				$this->error_msg.="Session username has been set up for $_SESSION[username]";
				return $_SESSION["username"];
			}
			return "undefined";
		}
	}
}
?>